#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

    int const N = 53;
    int const K = 10;
    int const M = 16;
    long long X = 1000'000'000'000'000;
    long long X_MAX = 1000'000'000'000'000'000;

    // @formatter:off
    vector<int> const         Ng{N, N, N, N, N,  25, 25, N,     N};
    vector<int> const         Kg{K, K, K, K, K,   K,  K, K,     K};
    vector<int> const         Mg{M, 0, 1, 2, M,   M,  M, M,     M};
    vector<long long> const KN4g{X, X, X, X, X, 400,  X, X, X_MAX};
    // @formatter:on

    int __g = validator.group().empty() ? 0 : stoi(validator.group());

    int n = inf.readInt(1, Ng[__g], "n");
    ensuref(n % 2 == 1, "n should be odd but instead is %d", n);
    inf.readSpace();
    long long k = inf.readInt(2, Kg[__g], "k");
    long long tmp = 1;
    for (int i = 0; i < n / 2; i++) {
        ensuref(KN4g[__g] / tmp >= k - 1, "k^ceil(n/4) should be less than 10^6");
        tmp *= (k - 1);
    }
    inf.readSpace();
    int m = inf.readInt(0, Mg[__g], "m");
    if (__g == 4) ensuref(k == m, "group 4: m should be equal to k but k = %lld, m = %d", k, m);
    if (__g == 8) ensuref(m >= 10, "group 8: m should be at least 10, but is %d", m);
    inf.readEoln();

    set<pair<int, int>> ps;
    for (int i = 0; i < m; i++) {
        int x = inf.readInt(1, k, format("x_%d", i + 1));
        inf.readSpace();
        int y = inf.readInt(1, k, format("y_%d", i + 1));
        inf.readEoln();

        ensuref(ps.count({x, y}) == 0, "pair (%d, %d) is repeating", x, y);
        ps.insert({x, y});
        if (__g == 4 || __g == 7) {
            ensuref(x == y, "group 4,7: x should be equal to y but got (%d, %d)", x, y);
        }
    }

    inf.readEof();

}