/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

int n, k, m;
int const MX = 16;
int const MOD = 1000'000'007;
using mask = bitset<MX>;
using item = pair<int, int>;

void gen(vector<int> &seq, mask &used, map<item, int> const &id, unordered_map<mask, ll> &out) {
    if (seq.size() == n) {
        out[used]++;
        return;
    }
    for (int i = 1; i < k; i++) {
        if (seq.size() % 2 && i != seq[seq.size() / 2]) continue;
        if (seq.empty()) {
            seq.push_back(i);
            gen(seq, used, id, out);
            seq.pop_back();
        } else {
            item key{seq.back(), i};
            int idx = id.count(key) ? id.at(key) : -1;
            if (idx > -1 && used[idx]) continue;

            seq.push_back(i);
            if (idx > -1) used.set(idx);
            gen(seq, used, id, out);
            if (idx > -1) used.set(idx, false);
            seq.pop_back();
        }
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> k >> m;
    n /= 2;
    vector<item> p(m), pr;
    map<item, int> pm, pmr;
    cin >> p;
    for (int i = 0; i < m; i++) {
        auto const &it = p[i];
        item rev{it.second, it.first};
        pr.emplace_back(rev);
        pm[it] = i;
        pmr[rev] = i;
    }

    unordered_map<mask, ll> c, cr;
    vector<int> seq;
    mask used;
    gen(seq, used, pm, c);
    gen(seq, used, pmr, cr);

    vector<ll> sum(1 << m, c[0]);
    for (int s1 = 0; s1 < (1 << m); s1++) {
        for (int s2 = s1; s2 > 0; s2 = (s2 - 1) & s1) {
            sum[s1] += c[s2];
        }
    }

    ll answer = 0;
    mask full = mask((1 << m) - 1);
    for (auto const &[m2, cnt2] : cr) {
        answer = (answer + sum[(full ^ m2).to_ulong()] * cnt2) % MOD;
    }

    cout << answer << '\n';

}