/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

int n, k, m;
int const MX = 17;
int const MOD = 1000'000'007;
ll answer = 0;
using mask = bitset<MX>;
using item = pair<int, int>;

void gen(vector<int> &seq, vector<item> const &fav) {
    if (seq.size() == n) {
        map<item, int> cnt;
        int c1 = (n - 1) / 2, c2 = c1 - 1;
        for (int i = 1; i < n; i++) {
            if (i == c1 + 1) continue;
            cnt[{seq[i - 1], seq[i]}]++;
        }
        for (auto const &it : fav) {
            if (cnt[it] > 1) return;
        }
        for (; c2 >= 0; c1--, c2 -= 2) {
            if (seq[c1] != seq[c2]) return;
            if (seq[n - c1 - 1] != seq[n - c2 - 1]) return;
        }
        answer++;
#ifdef LOCAL
        for (int si : seq) cout << si << ' ';
        cout << '\n';
#endif
        return;
    }
    for (int i = 1; i < k; i++) {
        seq.push_back(i);
        gen(seq, fav);
        seq.pop_back();
    }
}

int main() {

    cin >> n >> k >> m;
    n--;
    vector<item> p(m);
    cin >> p;

    vector<int> seq;
    gen(seq, p);

    cout << answer << '\n';

}