/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

struct dsu {

    vector<int> p, r;

    dsu(int n) : p(n), r(n) {
        iota(all(p), 0);
    }

    int get(int a) {
        if (a == p[a]) return a;
        return p[a] = get(p[a]);
    }

    void join(int a, int b) {
        a = get(a), b = get(b);
        if (r[a] < r[b]) swap(a, b);
        p[b] = a;
        r[a] += r[a] == r[b];
    }

};

using edge = tuple<int, int>;
using graph = vector<vector<edge>>;

vector<int> tin, tout, d;
int t = 0;
vector<vector<int>> up, m_up;

void dfs(int v, int depth, graph const &g) {
    d[v] = depth;
    tin[v] = t++;
    for (auto const &[u, a] : g[v]) {
        if (d[u] > -1) continue;
        up[0][u] = v;
        m_up[0][u] = a;
        dfs(u, depth + 1, g);
    }
    tout[v] = t++;
}

bool ancestor(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int max_edge(int u, int v) {
    static int lg = up.size();
    int w = INT_MIN;
    for (int b = lg - 1; b > -1; b--) {
        int high = up[b][u];
        if (ancestor(high, v)) continue;
        w = max(w, m_up[b][u]);
        u = high;
    }
    if (!ancestor(u, v)) {
        w = max(w, m_up[0][u]);
        u = up[0][u];
    }
    if (d[v] == d[u]) return w;
    int c = d[v] - d[u];
    for (int b = __lg(c); b > -1; b--) {
        if ((c >> b) & 1) {
            w = max(w, m_up[b][v]);
            v = up[b][v];
        }
    }
    return w;
}

int main() {
    fastio;
#ifdef LOCAL
    freopen("inf", "r", stdin);
#endif

    in(int, n, m)

    graph g(n);
    dsu c(n);
    ll weight = 0;
    vector<tuple<int, int, int>> edges;
    for (int i = 0; i < m; i++) {
        in(int, u, v, a)
        u--, v--;
        edges.emplace_back(a, u, v);
    }
    sort(all(edges));

    for (auto const &[a, u, v] : edges) {
        if (c.get(u) == c.get(v)) continue;
        c.join(u, v);
        weight += a;
        g[u].emplace_back(v, a);
        g[v].emplace_back(u, a);
    }

    tin.resize(n);
    tout.resize(n);
    d.resize(n, -1);
    int lg = __lg(n) + 1;
    up.resize(lg, vector<int>(n));
    m_up.resize(lg, vector<int>(n));
    dfs(0, 0, g);

    for (int b = 1; b < lg; b++) {
        m_up[b] = m_up[b - 1];
        for (int v = 0; v < n; v++) {
            int mid = up[b - 1][v];
            up[b][v] = up[b - 1][mid];
            m_up[b][v] = max(m_up[b][v], m_up[b - 1][mid]);
        }
    }

    vector<pair<int, int>> answer(n, {0, -1});
    for (auto const &[_, u, v] : edges) {
        int delta = -max_edge(u, v);
        pair<int, int> ku{delta, v}, kv{delta, u};
        answer[u] = min(answer[u], ku);
        answer[v] = min(answer[v], kv);
    }

    for (int v = 0; v < n; v++) {
        cout << answer[v].second + 1 << ' ';
    }
    cout << '\n';

}