/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

int main() {
    fastio;

    in(int, n, m)
    using edge = tuple<int, ll>;
    vector<vector<edge>> g(n);
    for (int i = 0; i < m; i++) {
        in(int, u, v, a)
        u--, v--;
        g[u].emplace_back(v, a);
        g[v].emplace_back(u, a);
    }

    auto contract = [&](int u, int v) {
        vector<vector<edge>> gc(n);
        for (int i = 0; i < n; i++) {
            int from = i == u ? v : i;
            for (auto const &[j, a] : g[i]) {
                int to = j == u ? v : j;
                gc[from].push_back({to, a});
            }
        }
        gc[v].emplace_back(u, 0);
        return gc;
    };

    ll const INF = INT_MAX;
    auto mst = [&](vector<vector<edge>> const &gc, int start) {
        vector<int> d(n, INF), used(n);
        d[start] = 0;
        set<pair<int, int>> q;
        for (int v = 0; v < n; v++) q.insert({d[v], v});
        ll weight = 0;

        while (!q.empty()) {
            auto [w, v] = *q.begin();
            weight += w;
            used[v] = 1;
            q.erase(q.begin());

            for (auto const &[u, a] : gc[v]) {
                if (d[u] <= a || used[u]) continue;
                q.erase({d[u], u});
                d[u] = a;
                q.insert({d[u], u});
            }
        }

        return weight;
    };

    for (int v = 0; v < n; v++) {
        int opt = -1;
        ll res = LLONG_MAX;
        for (auto const &[u, a] : g[v]) {
            auto gc = contract(u, v);
            ll w = mst(gc, v);
            if (w < res || w == res && u < opt) {
                res = w;
                opt = u;
            }
        }
        cout << opt + 1 << ' ';
    }
    cout << '\n';

}