#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

    int const N = 500'000;
    vector<int> const Ng{N, 10, 20, N, N, 1000, N};

    int __g = validator.group().empty() ? 0 : stoi(validator.group());

    auto s = inf.readToken("[a-z]+", "s");
    ensuref(s.size() <= Ng[__g], "group %d, size should not exceed %d", __g, Ng[__g]);
    inf.readEoln();

    auto t = inf.readToken("[a-z]+", "t");
    ensuref(t.size() <= N, "size of t should not exceed %d", N);
    inf.readEoln();

    if (__g == 3 || __g == 4) {
        ensuref(*max_element(s.begin(), s.end()) <= 'b', "groups 3,4: chars should not exceed 'b'");
        if (__g == 3) ensuref(count(s.begin(), s.end(), 'b') <= 1, "group 3: should contain no more than 1 'b'");
    }

    inf.readEof();

}